import scrapy
import datetime as dt
from creatures.items import Creature
from typing import List


class CreateListSpider(scrapy.Spider):
    name = "creatures"
    start_urls = ["https://pf2.d20pfsrd.com/monster"]

    def parse(self, response):
        rows = response.xpath('//table[@id="archive-data-table"]'
                              '/tr')
        creatures: List[Creature] = []
        for row in rows:
            name = row.xpath('.//td[1]/a/text()').get()
            family = row.xpath('.//td[2]/a/text()').get()
            level = row.xpath('.//td[3]/a/text()').get()
            publisher = row.xpath('.//td[4]/a/text()').get()
            source = row.xpath('.//td[5]/a/text()').get()
            url = row.xpath('.//td[1]/a/@href').get()
            creatures.append(Creature(name=name,
                                      family=family,
                                      level=level,
                                      publisher=publisher,
                                      source=source,
                                      url=url,))
        yield {
            'date': dt.datetime.now(tz=dt.timezone.utc),
            'data': creatures,
        }
